<?php
/**
 * CalculateForCheckoutResponseDataDiscounts
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\MarketingClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi. Marketing.
 *
 * Маркетинг
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\MarketingClient\Dto;

use \ArrayAccess;
use \Ensi\MarketingClient\ObjectSerializer;

/**
 * CalculateForCheckoutResponseDataDiscounts Class Doc Comment
 *
 * @category Class
 * @package  Ensi\MarketingClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class CalculateForCheckoutResponseDataDiscounts implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'CalculateForCheckoutResponse_data_discounts';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'name' => 'string',
        'type' => 'int',
        'external_type' => 'int',
        'change' => 'float',
        'seller_id' => 'int',
        'visible_in_catalog' => 'bool',
        'promo_code_only' => 'bool',
        'promo_code' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'name' => null,
        'type' => null,
        'external_type' => null,
        'change' => 'float',
        'seller_id' => null,
        'visible_in_catalog' => null,
        'promo_code_only' => null,
        'promo_code' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'name' => false,
        'type' => false,
        'external_type' => false,
        'change' => false,
        'seller_id' => false,
        'visible_in_catalog' => false,
        'promo_code_only' => false,
        'promo_code' => true
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'name' => 'name',
        'type' => 'type',
        'external_type' => 'external_type',
        'change' => 'change',
        'seller_id' => 'seller_id',
        'visible_in_catalog' => 'visible_in_catalog',
        'promo_code_only' => 'promo_code_only',
        'promo_code' => 'promo_code'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'name' => 'setName',
        'type' => 'setType',
        'external_type' => 'setExternalType',
        'change' => 'setChange',
        'seller_id' => 'setSellerId',
        'visible_in_catalog' => 'setVisibleInCatalog',
        'promo_code_only' => 'setPromoCodeOnly',
        'promo_code' => 'setPromoCode'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'name' => 'getName',
        'type' => 'getType',
        'external_type' => 'getExternalType',
        'change' => 'getChange',
        'seller_id' => 'getSellerId',
        'visible_in_catalog' => 'getVisibleInCatalog',
        'promo_code_only' => 'getPromoCodeOnly',
        'promo_code' => 'getPromoCode'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('type', $data, null);
        $this->setIfExists('external_type', $data, null);
        $this->setIfExists('change', $data, null);
        $this->setIfExists('seller_id', $data, null);
        $this->setIfExists('visible_in_catalog', $data, null);
        $this->setIfExists('promo_code_only', $data, null);
        $this->setIfExists('promo_code', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id Идентификатор скидки
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name Наименование скидки
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets type
     *
     * @return int|null
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param int|null $type Тип скидки из DiscountTypeEnum
     *
     * @return $this
     */
    public function setType($type)
    {


        /*if (is_null($type)) {
            throw new \InvalidArgumentException('non-nullable type cannot be null');
        }*/
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets external_type
     *
     * @return int|null
     */
    public function getExternalType()
    {
        return $this->container['external_type'];
    }

    /**
     * Sets external_type
     *
     * @param int|null $external_type Внешний тип скидки из DiscountExternalTypeEnum
     *
     * @return $this
     */
    public function setExternalType($external_type)
    {


        /*if (is_null($external_type)) {
            throw new \InvalidArgumentException('non-nullable external_type cannot be null');
        }*/
        $this->container['external_type'] = $external_type;

        return $this;
    }

    /**
     * Gets change
     *
     * @return float|null
     */
    public function getChange()
    {
        return $this->container['change'];
    }

    /**
     * Sets change
     *
     * @param float|null $change Итоговый размер скидки (в рублях)
     *
     * @return $this
     */
    public function setChange($change)
    {


        /*if (is_null($change)) {
            throw new \InvalidArgumentException('non-nullable change cannot be null');
        }*/
        $this->container['change'] = $change;

        return $this;
    }

    /**
     * Gets seller_id
     *
     * @return int|null
     */
    public function getSellerId()
    {
        return $this->container['seller_id'];
    }

    /**
     * Sets seller_id
     *
     * @param int|null $seller_id Идентификатор продавца
     *
     * @return $this
     */
    public function setSellerId($seller_id)
    {


        /*if (is_null($seller_id)) {
            throw new \InvalidArgumentException('non-nullable seller_id cannot be null');
        }*/
        $this->container['seller_id'] = $seller_id;

        return $this;
    }

    /**
     * Gets visible_in_catalog
     *
     * @return bool|null
     */
    public function getVisibleInCatalog()
    {
        return $this->container['visible_in_catalog'];
    }

    /**
     * Sets visible_in_catalog
     *
     * @param bool|null $visible_in_catalog Видна ли данная скидка в каталоге
     *
     * @return $this
     */
    public function setVisibleInCatalog($visible_in_catalog)
    {


        /*if (is_null($visible_in_catalog)) {
            throw new \InvalidArgumentException('non-nullable visible_in_catalog cannot be null');
        }*/
        $this->container['visible_in_catalog'] = $visible_in_catalog;

        return $this;
    }

    /**
     * Gets promo_code_only
     *
     * @return bool|null
     */
    public function getPromoCodeOnly()
    {
        return $this->container['promo_code_only'];
    }

    /**
     * Sets promo_code_only
     *
     * @param bool|null $promo_code_only Скидка действительно только по промокоду
     *
     * @return $this
     */
    public function setPromoCodeOnly($promo_code_only)
    {


        /*if (is_null($promo_code_only)) {
            throw new \InvalidArgumentException('non-nullable promo_code_only cannot be null');
        }*/
        $this->container['promo_code_only'] = $promo_code_only;

        return $this;
    }

    /**
     * Gets promo_code
     *
     * @return string|null
     */
    public function getPromoCode()
    {
        return $this->container['promo_code'];
    }

    /**
     * Sets promo_code
     *
     * @param string|null $promo_code Промокод
     *
     * @return $this
     */
    public function setPromoCode($promo_code)
    {

        if (is_null($promo_code)) {
            array_push($this->openAPINullablesSetToNull, 'promo_code');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('promo_code', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['promo_code'] = $promo_code;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


